/***********************************************************************
*				Combat System Demo by Zagreus							*
*		Feel free to use in your world and modify as you need.			*
*			Send questions or comments to Agentdex@sega.net				*
*	Special thanks to: Tom, Deadron, Zilal, Spuzzum, Air Mapster		*
*				And everyone else who helped me on the forums			*
************************************************************************/

mob

//Check battlearea of usr and run randomencounter proc for that area when move
	Move()
		switch(onbattlefield)
			if ("battlearea1")
				randomencounter1(src)
				return ..()
			else
				return ..()

	Move()
		switch(onbattlefield)
			if ("nobattles")
				none(src)
				return ..()
			else
				return ..()

	Move()
		switch(onbattlefield)
			if ("battlearea2")
				randomencounter2(src)
				return ..()
			else
				return ..()

	Move()
		switch(onbattlefield)
			if ("battlearea3")
				randomencounter3(src)
				return ..()
			else
				return ..()

	Move()
		switch(onbattlefield)
			if ("battlearea4")
				randomencounter4(src)
				return ..()
			else
				return ..()




//Battlearea as a variable so it can be assigned to the player
mob/var/turf/battlearea
mob/var/turf/battlearea2
mob/var/turf/nobattles
mob/var/turf/battlearea3
mob/var/turf/battlearea4



mob/proc

//25% chance of searching for unoccupied area and beginning combat.
	randomencounter1(mob/M as mob)
		var/turf/battlearea/T
		if (prob(15))
			for(T in world)
				if(!T.occupied)
					//usr << sound('FF7Enter Battle.wav')
					T.occupied = 1
					M.oldlocx = M.x
					M.oldlocy = M.y
					M.oldlocz = M.z
					M.battlearea = T
					spawn(1)M.Move(usr.battlearea)
					M.oldbattlefield = M.onbattlefield
					M.onbattlefield = null
					usr.dir = WEST
					M << "Fight!"
					usr.recalloff = 1
					usr.inabattle = 1
					usr << sound('ff7-norm.mid')
					M << "Click on the monster you wish to attack to start"
					usr.monrandom = rand(1,2)
					if(usr.monrandom == 1)
						spawn(1)new /mob/Saibman(locate(M.battlearea.x-4,M.battlearea.y,M.battlearea.z))
					if(usr.monrandom == 2)
						spawn(1)new /mob/redsaibman(locate(M.battlearea.x-4,M.battlearea.y,M.battlearea.z))
					sleep(5)
					usr.dir = WEST
					usr.icon_state = "sparstand"
					usr.move = 0
					return 1
			return 0



	randomencounter2(mob/M as mob)
		var/turf/battlearea/T
		if (prob(15))
			for(T in world)
				if(!T.occupied)
					//usr << sound('FF7Enter Battle.wav')
					T.occupied = 1
					M.oldlocx = M.x
					M.oldlocy = M.y
					M.oldlocz = M.z
					M.battlearea = T
					spawn(1)M.Move(usr.battlearea)
					M.oldbattlefield = M.onbattlefield
					M.onbattlefield = null
					usr.dir = WEST
					M << "Fight!"
					usr.inabattle = 1
					usr.recalloff = 1
					usr << sound('ff7-norm.mid')
					M << "Click on the monster you wish to attack to start"
					usr.monrandom = rand(1,2)
					if(usr.monrandom == 1)
						spawn(1)new /mob/bluesaibman(locate(M.battlearea.x-4,M.battlearea.y,M.battlearea.z))
					if(usr.monrandom == 2)
						spawn(1)new /mob/redsaibman(locate(M.battlearea.x-4,M.battlearea.y,M.battlearea.z))
					sleep(5)
					usr.dir = WEST
					usr.icon_state = "sparstand"
					usr.move = 0
					return 1
			return 0

	randomencounter3(mob/M as mob)
		var/turf/battlearea/T
		if (prob(15))
			for(T in world)
				if(!T.occupied)
					//usr << sound('FF7Enter Battle.wav')
					T.occupied = 1
					M.oldlocx = M.x
					M.oldlocy = M.y
					M.oldlocz = M.z
					M.battlearea = T
					spawn(1)M.Move(usr.battlearea)
					M.oldbattlefield = M.onbattlefield
					M.onbattlefield = null
					usr.dir = WEST
					M << "Fight!"
					usr.inabattle = 1
					usr.recalloff = 1
					usr << sound('ff7-norm.mid')
					M << "Click on the monster you wish to attack to start"
					usr.monrandom = rand(1,2)
					if(usr.monrandom == 1)
						spawn(1)new /mob/bluesaibman(locate(M.battlearea.x-4,M.battlearea.y,M.battlearea.z))
					if(usr.monrandom == 2)
						spawn(1)new /mob/soldier(locate(M.battlearea.x-4,M.battlearea.y,M.battlearea.z))
					sleep(5)
					usr.dir = WEST
					usr.icon_state = "sparstand"
					usr.move = 0
					return 1
			return 0

	boss1(mob/M as mob)
		var/turf/battlearea/T
		if (usr.killedboss == 0||usr.killedboss == null)
			for(T in world)
				if(!T.occupied)
					//usr << sound('FF7Enter Battle.wav')
					T.occupied = 1
					M.oldlocx = M.x
					M.oldlocy = M.y
					M.oldlocz = M.z
					M.battlearea = T
					spawn(1)M.Move(usr.battlearea)
					M.oldbattlefield = M.onbattlefield
					M.onbattlefield = null
					usr.dir = WEST
					M << "<b><font color=red>Fight!</font></b>"
					usr.inabattle = 1
					usr.recalloff = 1
					usr << sound('ff8=battle2.mid')
					M << "Click on the monster you wish to attack to start"
					spawn(1)new /mob/boss1(locate(M.battlearea.x-4,M.battlearea.y,M.battlearea.z))
					sleep(5)
					usr.dir = WEST
					usr.icon_state = "sparstand"
					usr.move = 0
					return 1
			return 0

	randomencounter4(mob/M as mob)
		var/turf/battlearea2/T
		if (prob(15))
			for(T in world)
				if(!T.occupied)
					//usr << sound('FF7Enter Battle.wav')
					T.occupied = 1
					M.oldlocx = M.x
					M.oldlocy = M.y
					M.oldlocz = M.z
					M.battlearea2 = T
					spawn(1)M.Move(usr.battlearea2)
					M.oldbattlefield = M.onbattlefield
					M.onbattlefield = null
					usr.dir = WEST
					M << "Fight!"
					usr.recalloff = 1
					usr.inabattle = 1
					usr << sound('wunrebat.mid')
					M << "Click on the monster you wish to attack to start"
					usr.monrandom = rand(1,2)
					if(usr.monrandom == 1)
						spawn(1)new /mob/soldier2(locate(M.battlearea2.x-4,M.battlearea2.y,M.battlearea2.z))
					if(usr.monrandom == 2)
						spawn(1)new /mob/soldier3(locate(M.battlearea2.x-4,M.battlearea2.y,M.battlearea2.z))
					sleep(5)
					usr.dir = WEST
					usr.icon_state = "sparstand"
					usr.move = 0
					return 1
			return 0
	none(mob/M as mob)

//Maincombat proc called on Click() for the monster. Gives options and stuff.
	maincombat(mob/attacker as mob, mob/target as mob)
		usr.clik = 1
		var/list/CombatOps1 = list("Attack", "Run", "KI", "Item")
		//usr << sound('FF7YourTurn Battle.wav')
		var/CombatOp1 = input(usr, "What do you wish to do?", "Combat", "Attack") in CombatOps1

		switch (CombatOp1)
			if ("Attack")
				attack(attacker, target)
				usr.clik = 0
			if ("Run")
				flee(attacker, target)
				usr.clik = 0
			if ("KI")
				magic(attacker, target)
				usr.clik = 0
			if ("Item")
				usr << "<i><b><font color=red><b>To use an item in battle, use an item like you were not in battle through the inventory tab!</font color></i>   Click the enemy to continue your battle!</b>"
				usr.clik = 0




//attacker chose attack on main menu, see if  or miss, if hit go to damage proc
	attack(mob/attacker as mob, mob/target as mob)
		attacker << "<font color=red><b>You chose to attack [src]"
		flick("sparfury",usr)
		if(prob(attacker.hit - target.evade))
			normaldamage(attacker, target)
		else
			attacker << "<font color=red><b>You miss!"
			//usr << sound('FF7Miss Attack.wav')
			npcattack1(attacker, target)

	kiblast(mob/attacker as mob, mob/target as mob)
		attacker << "<font color=red><b>You blast [src] with a KI Blast!"
		attacker.HP -= 25
		if (attacker.HP <=0)
			alert (attacker, "You have killed yourself!")
			world << "<b><font color=lime>[attacker] killed himself!</b></font>"
			usr << sound('w1000b.mid')
			attacker.exp -= (attacker.exp / 2)
			attacker.loc = locate(54,9,3)  //Change this to where you want dead people to respawn
			usr.overlays += 'halo.dmi'
			usr.dead = 1
			usr.move = 1
			usr.sand = 0
			usr.icon_state = ""
			usr.inabattle = 0
			usr.clik = 0
			var/turf/battlearea/T = attacker.battlearea
			T.occupied = 0
			attacker.battlearea = null
			attacker.onbattlefield = null
			attacker.oldbattlefield = null
			attacker.HP = attacker.MAXHP
			del (target)
		//Player is still alive, so go back to main combat menu
		else
			if(prob(attacker.hit - target.evade))
				kiblastdamage(attacker, target)
			else
				attacker << "<font color=red><b>You miss!"
				//usr << sound('FF7Miss Attack.wav')
				npcattack1(attacker, target)
	kameblast(mob/attacker as mob, mob/target as mob)
		attacker << "<font color=red><b>You fire at [src] with a Kamehameha Wave!"
		attacker.HP -= 25
		if (attacker.HP <=0)
			alert (attacker, "You have killed yourself!")
			world << "<b><font color=lime>[attacker] killed himself!</b></font>"
			usr << sound('w1000b.mid')
			attacker.exp -= (attacker.exp / 2)
			attacker.loc = locate(54,9,3)  //Change this to where you want dead people to respawn
			usr.overlays += 'halo.dmi'
			usr.dead = 1
			usr.move = 1
			usr.sand = 0
			usr.icon_state = ""
			usr.inabattle = 0
			usr.clik = 0
			var/turf/battlearea/T = attacker.battlearea
			T.occupied = 0
			attacker.battlearea = null
			attacker.onbattlefield = null
			attacker.oldbattlefield = null
			attacker.HP = attacker.MAXHP
			del (target)
		//Player is still alive, so go back to main combat menu
		else
			if(prob(attacker.hit - target.evade))
				kameblastdamage(attacker, target)
			else
				attacker << "<font color=red><b>You miss!"
				//usr << sound('FF7Miss Attack.wav')
				npcattack1(attacker, target)


//usr choses flee on main combat menu, return to oldloc and clear battle vars if success
	flee(mob/attacker as mob, mob/target as mob)
		if (rand(1,3) == 1)
			attacker << "<font color=red><b>You successfuly run from [target]"
			//usr << sound('Escape.wav')
			usr.clik = 0
			endbattle(attacker)
			del(target)
		else
			attacker << "<font color=red><b>You failed to run and loose a turn!"
			npcattack1(attacker, target)


//You didn't think you'd get a fully working magic system in my demo, did you?
	magic(mob/attacker as mob, mob/target as mob)
		//MagicOp1.Add("Item1","Item2")
		//usr << "Not implemented yet.  Click enemy again to continue battle!"
		usr.clik = 1
		var/list/MagicOps1 = list("KI Blast --- 25HP","Cancel")
		var/MagicOp1 = input(usr, "What do you wish to do?", "KI Attacks") in MagicOps1
	//	if(usr.kameblastlearn == 1)
		//	MagicOp1.Add("Kamehameha Wave --- 100HP")
		switch (MagicOp1)
			if ("KI Blast --- 25HP")
				kiblast(attacker, target)
				usr.clik = 0
			if ("Kamehameha Wave --- 100HP")
				kameblast(attacker, target)
				usr.clik = 0
			if("Cancel")
				usr << "<b>Action Cancelled!  Click the monster again to resume combat!</b>"
				usr.clik = 0





//Deal damage
	normaldamage(mob/attacker as mob, mob/target as mob)
		var/maxdamage = attacker.attack - target.defense - (target.agility / 15)
		var/damage = rand ((maxdamage / 2), maxdamage)
		if (damage <= 0)
			attacker << "<font color=red><b>You miss! (0 dmg)"
			//usr << sound('FF7Miss Attack.wav')
			npcattack1(attacker, target)
		else
			attacker << "<font color=red><b>You hit [src] for [damage] points of damage with a normal attack!"
			//usr << sound ('FF7Cut Attack.wav')
			target.HP -= damage
			npcdeathcheck(attacker, target)

	kiblastdamage(mob/attacker as mob, mob/target as mob)
		var/maxdamage = attacker.attack - (target.agility / 15)
		var/damage = rand ((maxdamage), maxdamage)
		if (damage <= 0)
			attacker << "<font color=red><b>You miss! (0 dmg)"
			//usr << sound('FF7Miss Attack.wav')
			npcattack1(attacker, target)
		else
			flick("sparfury",usr)
			sleep(2)
			s_missile('kame.dmi', attacker, target)
			attacker << "<font color=red><b>You hit [src] for [damage] points of damage with a KI Blast attack!"
			//usr << sound ('FF7Cut Attack.wav')
			target.HP -= damage
			sleep(10)
			flick('BOOM.dmi',target)
			npcdeathcheck(attacker, target)
	kameblastdamage(mob/attacker as mob, mob/target as mob)
		var/maxdamage = (attacker.attack * 2)
		var/damage = rand ((maxdamage), maxdamage)
		if (damage <= 0)
			attacker << "<font color=red><b>You miss! (0 dmg)"
			//usr << sound('FF7Miss Attack.wav')
			npcattack1(attacker, target)
		else
			usr << "Kah!"
			sleep(10)
			usr.overlays += 'charge1.dmi'
			sleep(10)
			usr << "Meh!"
			sleep(20)
			usr << "Hah!"
			sleep(20)
			usr << "Meh!"
			sleep(30)
			usr << "Hah!"
			usr.overlays -= 'charge1.dmi'
			flick("sparfury",usr)
			sleep(2)
			s_missile('kame.dmi', attacker, target)
			attacker << "<font color=red><b>You hit [src] for [damage] points of damage with a Kamehameha Wave attack!"
			//usr << sound ('FF7Cut Attack.wav')
			target.HP -= damage
			sleep(10)
			flick('BOOM.dmi',target)
			npcdeathcheck(attacker, target)




//Time for the monster to attack If miss go back to maincombat.
	npcattack1(mob/defender as mob, mob/monster as mob)
		if (prob (monster.hit))
			defender << "<font color=yellow><i>The [monster] attacks you and hits!"
			//usr << sound('FF7Hit Attack.wav')
			var/maxdamage = monster.attack - (defender.defense / 4) - (defender.agility / 20)
			var/damage = rand ((maxdamage / 2), maxdamage)
			if (damage <= 0)
				defender << "<font color=yellow><i>The attack bounces harmlessly off you."
				maincombat(defender, monster)
			else
				defender << "<font color=yellow><i>Hit for [damage] damage!"
				defender.HP -= damage
				playerdeathcheck(defender, monster)
		else
			defender << "<font color=yellow><i>The [monster] attacks you and misses!"
			//usr << sound('FF7Miss Attack.wav')
			maincombat(defender, monster)


//Return the user to their original loc and clear battle variables.
	endbattle(mob/M as mob)
		if(usr.sand == 0||usr.sand == null)
			var/turf/battlearea/T = M.battlearea
			T.occupied = 0
			M.battlearea = null
			M.loc = locate(M.oldlocx,M.oldlocy,M.oldlocz)
			M.onbattlefield = M.oldbattlefield
			M.oldbattlefield = null
			M.oldlocx = null
			M.oldlocy = null
			M.oldlocz = null
			usr.icon_state = ""
			usr.move = 1
			checklevel(M)
		if(usr.sand == 1)
			var/turf/battlearea2/T = M.battlearea2
			T.occupied = 0
			M.battlearea2 = null
			M.loc = locate(M.oldlocx,M.oldlocy,M.oldlocz)
			M.onbattlefield = M.oldbattlefield
			M.oldbattlefield = null
			M.oldlocx = null
			M.oldlocy = null
			M.oldlocz = null
			usr.icon_state = ""
			usr.move = 1
			checklevel(M)


